diff --git a/examples/CrlExample.c b/examples/CrlExample.c
index 1e59ac7..45099e2 100644
--- a/examples/CrlExample.c
+++ b/examples/CrlExample.c
@@ -27,7 +27,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 
 
@@ -93,7 +93,7 @@ get_Name_type (ASN1_TYPE cert_def, ASN1_TYPE cert, const char *root,
       strcat (name, counter);
 
       len = sizeof (str) - 1;
-      result = asn1_read_value (cert, name, str, &len);
+      result = asn1_internal_read_value (cert, name, str, &len);
       if (result == ASN1_ELEMENT_NOT_FOUND)
 	break;
       k2 = 1;
@@ -105,97 +105,97 @@ get_Name_type (ASN1_TYPE cert_def, ASN1_TYPE cert, const char *root,
 	  strcat (name2, counter);
 
 	  len = sizeof (str) - 1;
-	  result = asn1_read_value (cert, name2, str, &len);
+	  result = asn1_internal_read_value (cert, name2, str, &len);
 	  if (result == ASN1_ELEMENT_NOT_FOUND)
 	    break;
 	  strcpy (name3, name2);
 	  strcat (name3, ".type");
 
 	  len = sizeof (str) - 1;
-	  result = asn1_read_value (cert, name3, str, &len);
+	  result = asn1_internal_read_value (cert, name3, str, &len);
 	  strcpy (name3, name2);
 	  strcat (name3, ".value");
 	  if (result == ASN1_SUCCESS)
 	    {
 	      len = sizeof (str2);
 	      result =
-		asn1_read_value (cert_def,
+		asn1_internal_read_value (cert_def,
 				 "PKIX1Implicit88.id-at-countryName", str2,
 				 &len);
 	      if (!strcmp (str, str2))
 		{
-		  asn1_create_element (cert_def,
-				       "PKIX1Implicit88.X520OrganizationName",
-				       &value);
+		  asn1_internal_create_element (cert_def,
+						"PKIX1Implicit88.X520OrganizationName",
+						&value);
 		  len = sizeof (str) - 1;
-		  asn1_read_value (cert, name3, str, &len);
+		  asn1_internal_read_value (cert, name3, str, &len);
 		  result =
-		    asn1_der_decoding (&value, str, len, errorDescription);
+		    asn1_internal_der_decoding (&value, str, len, errorDescription);
 
 		  len = sizeof (str) - 1;
-		  asn1_read_value (value, "", str, &len);	/* CHOICE */
+		  asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 
 		  strcpy (name3, str);
 
 		  len = sizeof (str) - 1;
-		  asn1_read_value (value, name3, str, &len);
+		  asn1_internal_read_value (value, name3, str, &len);
 		  str[len] = 0;
 		  strcat (answer, " C=");
 		  strcat (answer, str);
 
-		  asn1_delete_structure (&value);
+		  asn1_internal_delete_structure (&value);
 		}
 	      else
 		{
 		  len = sizeof (str2);
 		  result =
-		    asn1_read_value (cert_def,
+		    asn1_internal_read_value (cert_def,
 				     "PKIX1Implicit88.id-at-organizationName",
 				     str2, &len);
 		  if (!strcmp (str, str2))
 		    {
-		      asn1_create_element (cert_def,
-					   "PKIX1Implicit88.X520OrganizationName",
-					   &value);
+		      asn1_internal_create_element (cert_def,
+						    "PKIX1Implicit88.X520OrganizationName",
+						    &value);
 
 		      len = sizeof (str) - 1;
-		      asn1_read_value (cert, name3, str, &len);
-		      asn1_der_decoding (&value, str, len, errorDescription);
+		      asn1_internal_read_value (cert, name3, str, &len);
+		      asn1_internal_der_decoding (&value, str, len, errorDescription);
 		      len = sizeof (str) - 1;
-		      asn1_read_value (value, "", str, &len);	/* CHOICE */
+		      asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 		      strcpy (name3, str);
 		      len = sizeof (str) - 1;
-		      asn1_read_value (value, name3, str, &len);
+		      asn1_internal_read_value (value, name3, str, &len);
 		      str[len] = 0;
 		      strcat (answer, " O=");
 		      strcat (answer, str);
-		      asn1_delete_structure (&value);
+		      asn1_internal_delete_structure (&value);
 		    }
 		  else
 		    {
 		      len = sizeof (str2);
 		      result =
-			asn1_read_value (cert_def,
+			asn1_internal_read_value (cert_def,
 					 "PKIX1Implicit88.id-at-organizationalUnitName",
 					 str2, &len);
 		      if (!strcmp (str, str2))
 			{
-			  asn1_create_element (cert_def,
-					       "PKIX1Implicit88.X520OrganizationalUnitName",
-					       &value);
+			  asn1_internal_create_element (cert_def,
+							"PKIX1Implicit88.X520OrganizationalUnitName",
+							&value);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (cert, name3, str, &len);
-			  asn1_der_decoding (&value, str, len,
+			  asn1_internal_read_value (cert, name3, str, &len);
+			  asn1_internal_der_decoding (&value, str, len,
 					     errorDescription);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (value, "", str, &len);	/* CHOICE */
+			  asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 			  strcpy (name3, str);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (value, name3, str, &len);
+			  asn1_internal_read_value (value, name3, str, &len);
 			  str[len] = 0;
 			  strcat (answer, " OU=");
 			  strcat (answer, str);
-			  asn1_delete_structure (&value);
+			  asn1_internal_delete_structure (&value);
 			}
 		    }
 		}
@@ -232,7 +232,7 @@ create_CRL (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
   max_len = *der_len;
 
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.CertificateList", &crl);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.CertificateList", &crl);
 
   /* Use the next 3 lines to visit the empty certificate */
   /*  printf("-----------------\n");
@@ -241,156 +241,156 @@ create_CRL (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
 
 
   /* version: v2(1) */
-  result = asn1_write_value (crl, "tbsCertList.version", "v2", 0);
+  result = asn1_internal_write_value (crl, "tbsCertList.version", "v2", 0);
 
 
   /* signature: dsa-with-sha */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
-  result = asn1_write_value (crl, "tbsCertList.signature.algorithm", str, 1);
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
+  result = asn1_internal_write_value (crl, "tbsCertList.signature.algorithm", str, 1);
   result =
-    asn1_write_value (crl, "tbsCertList.signature.parameters", NULL, 0);
+    asn1_internal_write_value (crl, "tbsCertList.signature.parameters", NULL, 0);
 
 
   /* issuer: Country="US" Organization="gov" OrganizationUnit="nist" */
-  result = asn1_write_value (crl, "tbsCertList.issuer", "rdnSequence", 1);
+  result = asn1_internal_write_value (crl, "tbsCertList.issuer", "rdnSequence", 1);
 
-  result = asn1_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 1);
+  result = asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 1);
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 1);
   /* C */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
 		     &len);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
-  result = asn1_write_value (value, "", "US", 2);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
+  result = asn1_internal_write_value (value, "", "US", 2);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
 
-  asn1_delete_structure (&value);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
-  result = asn1_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 4);
+  result = asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 4);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 4);
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 4);
   /* O */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
 		     &len);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 8);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "gov", 3);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "gov", 3);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
-  result = asn1_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 1);
+  result = asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 1);
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST", "NEW", 1);
   /* OU */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
 		     str, &len);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def,
-			 "PKIX1Implicit88.X520OrganizationalUnitName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "nist", 4);
+    asn1_internal_create_element (cert_def,
+				  "PKIX1Implicit88.X520OrganizationalUnitName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "nist", 4);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
+    asn1_internal_write_value (crl, "tbsCertList.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   /* validity */
-  result = asn1_write_value (crl, "tbsCertList.thisUpdate", "utcTime", 1);
+  result = asn1_internal_write_value (crl, "tbsCertList.thisUpdate", "utcTime", 1);
   result =
-    asn1_write_value (crl, "tbsCertList.thisUpdate.utcTime", "970801000000Z",
+    asn1_internal_write_value (crl, "tbsCertList.thisUpdate.utcTime", "970801000000Z",
 		      1);
 
-  result = asn1_write_value (crl, "tbsCertList.nextUpdate", "utcTime", 1);
+  result = asn1_internal_write_value (crl, "tbsCertList.nextUpdate", "utcTime", 1);
   result =
-    asn1_write_value (crl, "tbsCertList.nextUpdate.utcTime", "970808000000Z",
+    asn1_internal_write_value (crl, "tbsCertList.nextUpdate.utcTime", "970808000000Z",
 		      1);
 
 
   /* revokedCertificates */
   result =
-    asn1_write_value (crl, "tbsCertList.revokedCertificates", "NEW", 1);
+    asn1_internal_write_value (crl, "tbsCertList.revokedCertificates", "NEW", 1);
   str[0] = 18;
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.userCertificate",
 		      str, 1);
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.revocationDate",
 		      "utcTime", 1);
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.revocationDate.utcTime",
 		      "970731000000Z", 1);
 
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.crlEntryExtensions",
 		      "NEW", 1);
   len = sizeof (str) - 1;
-  result = asn1_read_value (cert_def, "PKIX1Implicit88.id-ce-cRLReasons",
+  result = asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-ce-cRLReasons",
 			    str, &len);
-  result = asn1_write_value (crl, "tbsCertList.revokedCertificates.?LAST.crlEntryExtensions.?LAST.extnID", str, 1);	/* reasonCode */
+  result = asn1_internal_write_value (crl, "tbsCertList.revokedCertificates.?LAST.crlEntryExtensions.?LAST.extnID", str, 1);	/* reasonCode */
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.crlEntryExtensions.?LAST.critical",
 		      "FALSE", 1);
   str2 = (const unsigned char *) "\x0a\x01\x01";
   result =
-    asn1_write_value (crl,
+    asn1_internal_write_value (crl,
 		      "tbsCertList.revokedCertificates.?LAST.crlEntryExtensions.?LAST.extnValue",
 		      str2, 3);
 
 
   /* crlExtensions */
-  result = asn1_write_value (crl, "tbsCertList.crlExtensions", NULL, 0);
+  result = asn1_internal_write_value (crl, "tbsCertList.crlExtensions", NULL, 0);
 
 
   /* signatureAlgorithm: dsa-with-sha  */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
-  result = asn1_write_value (crl, "signatureAlgorithm.algorithm", str, 1);
-  result = asn1_write_value (crl, "signatureAlgorithm.parameters", NULL, 0);	/* NO OPTION */
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
+  result = asn1_internal_write_value (crl, "signatureAlgorithm.algorithm", str, 1);
+  result = asn1_internal_write_value (crl, "signatureAlgorithm.parameters", NULL, 0);	/* NO OPTION */
 
   /* signature */
   *der_len = max_len;
   result =
-    asn1_der_coding (crl, "tbsCertList", der, der_len, errorDescription);
+    asn1_internal_der_coding (crl, "tbsCertList", der, der_len, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("\n'tbsCertList' encoding creation: ERROR\n");
@@ -398,7 +398,7 @@ create_CRL (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
     }
 
   /* add the lines for the signature on der[0]..der[der_len-1]: result in str2 */
-  result = asn1_write_value (crl, "signature", str2, 46 * 8);
+  result = asn1_internal_write_value (crl, "signature", str2, 46 * 8);
 
 
   /* Use the next 3 lines to visit the certificate */
@@ -407,7 +407,7 @@ create_CRL (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
      printf("-----------------\n"); */
 
   *der_len = max_len;
-  result = asn1_der_coding (crl, "", der, der_len, errorDescription);
+  result = asn1_internal_der_coding (crl, "", der, der_len, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("\n'crl1' encoding creation: ERROR\n");
@@ -422,7 +422,7 @@ create_CRL (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
   printf ("\n-----------------\n");
 
   /* Clear the "certificate1" structure */
-  asn1_delete_structure (&crl);
+  asn1_internal_delete_structure (&crl);
 }
 
 
@@ -445,9 +445,9 @@ get_CRL (ASN1_TYPE cert_def, unsigned char *der, int der_len)
   char errorDescription[ASN1_MAX_ERROR_DESCRIPTION_SIZE];
 
 
-  asn1_create_element (cert_def, "PKIX1Implicit88.CertificateList", &crl2);
+  asn1_internal_create_element (cert_def, "PKIX1Implicit88.CertificateList", &crl2);
 
-  result = asn1_der_decoding (&crl2, der, der_len, errorDescription);
+  result = asn1_internal_der_decoding (&crl2, der, der_len, errorDescription);
 
   if (result != ASN1_SUCCESS)
     {
@@ -463,20 +463,20 @@ get_CRL (ASN1_TYPE cert_def, unsigned char *der, int der_len)
 
   /* Verify sign */
   len = sizeof (str) - 1;
-  result = asn1_read_value (crl2, "signatureAlgorithm.algorithm", str, &len);
+  result = asn1_internal_read_value (crl2, "signatureAlgorithm.algorithm", str, &len);
 
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str2,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str2,
 		     &len);
   if (!strcmp ((char *) str, (char *) str2))
     {				/* dsa-with-sha */
 
-      result = asn1_der_decoding_startEnd (crl2, der, der_len,
+      result = asn1_internal_der_decoding_startEnd (crl2, der, der_len,
 					   "tbsCertList", &start, &end);
 
       /* add the lines to calculate the sha on der[start]..der[end] */
 
-      result = asn1_read_value (crl2, "signature", str, &len);
+      result = asn1_internal_read_value (crl2, "signature", str, &len);
 
       /* compare the previous value to signature ( with issuer public key) */
     }
@@ -488,7 +488,7 @@ get_CRL (ASN1_TYPE cert_def, unsigned char *der, int der_len)
 
 
   /* Clear the "crl2" structure */
-  asn1_delete_structure (&crl2);
+  asn1_internal_delete_structure (&crl2);
 }
 
 extern const ASN1_ARRAY_TYPE pkix_asn1_tab[];
@@ -510,14 +510,14 @@ main (int argc, char *argv[])
 
   if (1)
     result =
-      asn1_array2tree (pkix_asn1_tab, &PKIX1Implicit88, errorDescription);
+      asn1_internal_array2tree (pkix_asn1_tab, &PKIX1Implicit88, errorDescription);
   else
     result =
-      asn1_parser2tree ("pkix.asn", &PKIX1Implicit88, errorDescription);
+      asn1_internal_parser2tree ("pkix.asn", &PKIX1Implicit88, errorDescription);
 
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("%s\n", errorDescription);
       exit (1);
     }
@@ -534,7 +534,7 @@ main (int argc, char *argv[])
   get_CRL (PKIX1Implicit88, der, der_len);
 
   /* Clear the "PKIX1Implicit88" structures */
-  asn1_delete_structure (&PKIX1Implicit88);
+  asn1_internal_delete_structure (&PKIX1Implicit88);
 
   return 0;
 }
diff --git a/examples/pkix_asn1_tab.c b/examples/pkix_asn1_tab.c
index b65f622..679cca5 100644
--- a/examples/pkix_asn1_tab.c
+++ b/examples/pkix_asn1_tab.c
@@ -2,7 +2,7 @@
 # include "config.h"
 #endif
 
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 const asn1_static_node pkix_asn1_tab[] = {
   { "PKIX1Implicit88", 536875024, NULL },
diff --git a/lib/ASN1.y b/lib/ASN1.y
index 731415d..53a6b88 100644
--- a/lib/ASN1.y
+++ b/lib/ASN1.y
@@ -30,7 +30,7 @@
 #include <int.h>
 #include <parser_aux.h>
 #include <structure.h>
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 static FILE *file_asn1;			/* Pointer to file to parse */
 static int result_parse = 0;	/* result of the parser
@@ -657,8 +657,8 @@ _asn1_create_errorDescription (int error, char *error_desc)
  *   characters.
  **/
 int
-asn1_parser2tree (const char *file, asn1_node * definitions,
-                  char *error_desc)
+asn1_internal_parser2tree (const char *file, asn1_node * definitions,
+			   char *error_desc)
 {
 
   p_tree = NULL;
@@ -745,8 +745,8 @@ asn1_parser2tree (const char *file, asn1_node * definitions,
  *   characters.
  **/
 int
-asn1_parser2array (const char *inputFileName, const char *outputFileName,
-                   const char *vectorName, char *error_desc)
+asn1_internal_parser2array (const char *inputFileName, const char *outputFileName,
+			    const char *vectorName, char *error_desc)
 {
   char *file_out_name = NULL;
   char *vector_name = NULL;
diff --git a/lib/Makefile.am b/lib/Makefile.am
index 8b6a0f0..3e8c37d 100644
--- a/lib/Makefile.am
+++ b/lib/Makefile.am
@@ -28,22 +28,23 @@ pkgconfig_DATA = libtasn1.pc
 
 lib_LTLIBRARIES = libtasn1.la
 
-libtasn1_la_SOURCES =	\
-	ASN1.y		\
-	coding.c	\
-	decoding.c	\
-	element.c	\
-	element.h	\
-	errors.c	\
-	gstr.c		\
-	gstr.h		\
-	int.h		\
-	libtasn1.h	\
-	libtasn1.map	\
-	parser_aux.c	\
-	parser_aux.h	\
-	structure.c	\
-	structure.h	\
+libtasn1_la_SOURCES =				\
+	ASN1.y					\
+	coding.c				\
+	compat-wrapper.c			\
+	decoding.c				\
+	element.c				\
+	element.h				\
+	errors.c				\
+	gstr.c					\
+	gstr.h					\
+	int.h					\
+	libtasn1.h				\
+	libtasn1.map				\
+	parser_aux.c				\
+	parser_aux.h				\
+	structure.c				\
+	structure.h				\
 	version.c
 
 libtasn1_la_LIBADD = gllib/libgnu.la
diff --git a/lib/coding.c b/lib/coding.c
index d6b7cf4..23ad4fb 100644
--- a/lib/coding.c
+++ b/lib/coding.c
@@ -72,7 +72,7 @@ _asn1_error_description_value_not_found (asn1_node node,
  * To know the size of the DER encoding use a %NULL value for @der.
  **/
 void
-asn1_length_der (unsigned long int len, unsigned char *der, int *der_len)
+asn1_internal_length_der (unsigned long int len, unsigned char *der, int *der_len)
 {
   int k;
   unsigned char temp[ASN1_MAX_LENGTH_SIZE];
@@ -170,15 +170,15 @@ _asn1_tag_der (unsigned char class, unsigned int tag_value,
  * asn1_length_der().
  **/
 void
-asn1_octet_der (const unsigned char *str, int str_len,
-		unsigned char *der, int *der_len)
+asn1_internal_octet_der (const unsigned char *str, int str_len,
+			 unsigned char *der, int *der_len)
 {
   int len_len;
 
   if (der == NULL || str_len < 0)
     return;
 
-  asn1_length_der (str_len, der, &len_len);
+  asn1_internal_length_der (str_len, der, &len_len);
   memcpy (der + len_len, str, str_len);
   *der_len = str_len + len_len;
 }
@@ -202,9 +202,9 @@ asn1_octet_der (const unsigned char *str, int str_len,
  * Returns: %ASN1_SUCCESS if successful or an error value.
  **/
 int
-asn1_encode_simple_der (unsigned int etype, const unsigned char *str,
-			unsigned int str_len, unsigned char *tl,
-			unsigned int *tl_len)
+asn1_internal_encode_simple_der (unsigned int etype, const unsigned char *str,
+				 unsigned int str_len, unsigned char *tl,
+				 unsigned int *tl_len)
 {
   int tag_len, len_len;
   unsigned tlen;
@@ -224,7 +224,7 @@ asn1_encode_simple_der (unsigned int etype, const unsigned char *str,
 
   _asn1_tag_der (ETYPE_CLASS (etype), ETYPE_TAG (etype), der_tag, &tag_len);
 
-  asn1_length_der (str_len, der_length, &len_len);
+  asn1_internal_length_der (str_len, der_length, &len_len);
 
   if (tag_len <= 0 || len_len <= 0)
     return ASN1_VALUE_NOT_VALID;
@@ -267,7 +267,7 @@ _asn1_time_der (unsigned char *str, int str_len, unsigned char *der,
 
   max_len = *der_len;
 
-  asn1_length_der (str_len, (max_len > 0) ? der : NULL, &len_len);
+  asn1_internal_length_der (str_len, (max_len > 0) ? der : NULL, &len_len);
 
   if ((len_len + str_len) <= max_len)
     memcpy (der + len_len, str, str_len);
@@ -288,7 +288,7 @@ _asn1_get_utctime_der(unsigned char *der,int *der_len,unsigned char *str)
   char temp[20];
 
   if(str==NULL) return;
-  str_len=asn1_get_length_der(der,*der_len,&len_len);
+  str_len=asn1_internal_get_length_der(der,*der_len,&len_len);
   if (str_len<0) return;
   memcpy(temp,der+len_len,str_len);
   *der_len=str_len+len_len;
@@ -387,11 +387,11 @@ _asn1_objectid_der (unsigned char *str, unsigned char *der, int *der_len)
       n_start = n_end + 1;
     }
 
-  asn1_length_der (*der_len, NULL, &len_len);
+  asn1_internal_length_der (*der_len, NULL, &len_len);
   if (max_len >= (*der_len + len_len))
     {
       memmove (der + len_len, der, *der_len);
-      asn1_length_der (*der_len, der, &len_len);
+      asn1_internal_length_der (*der_len, der, &len_len);
     }
   *der_len += len_len;
 
@@ -427,8 +427,8 @@ static const unsigned char bit_mask[] =
  * asn1_length_der().
  **/
 void
-asn1_bit_der (const unsigned char *str, int bit_len,
-	      unsigned char *der, int *der_len)
+asn1_internal_bit_der (const unsigned char *str, int bit_len,
+		       unsigned char *der, int *der_len)
 {
   int len_len, len_byte, len_pad;
 
@@ -441,7 +441,7 @@ asn1_bit_der (const unsigned char *str, int bit_len,
     len_pad = 0;
   else
     len_byte++;
-  asn1_length_der (len_byte + 1, der, &len_len);
+  asn1_internal_length_der (len_byte + 1, der, &len_len);
   der[len_len] = len_pad;
   memcpy (der + len_len + 1, str, len_byte);
   der[len_len + len_byte] &= bit_mask[len_pad];
@@ -493,7 +493,7 @@ _asn1_complete_explicit_tag (asn1_node node, unsigned char *der,
 		{
 		  len2 = strtol (p->name, NULL, 10);
 		  _asn1_set_name (p, NULL);
-		  asn1_length_der (*counter - len2, temp, &len3);
+		  asn1_internal_length_der (*counter - len2, temp, &len3);
 		  if (len3 <= (*max_len))
 		    {
 		      memmove (der + len2 + len3, der + len2,
@@ -749,7 +749,7 @@ _asn1_ordering_set (unsigned char *der, int der_len, asn1_node node)
       last = p_vet;
 
       /* tag value calculation */
-      err = asn1_get_tag_der (der + counter, der_len - counter, &class, &len2,
+      err = asn1_internal_get_tag_der (der + counter, der_len - counter, &class, &len2,
 			      &tag);
       if (err != ASN1_SUCCESS)
 	goto error;
@@ -759,7 +759,7 @@ _asn1_ordering_set (unsigned char *der, int der_len, asn1_node node)
       counter += len2;
 
       /* extraction and length */
-      len2 = asn1_get_length_der (der + counter, der_len - counter, &len);
+      len2 = asn1_internal_get_length_der (der + counter, der_len - counter, &len);
       if (len2 < 0)
 	{
 	  err = ASN1_DER_ERROR;
@@ -892,13 +892,13 @@ _asn1_ordering_set_of (unsigned char *der, int der_len, asn1_node node)
       if (der_len - counter > 0)
 	{
 
-	  err = asn1_get_tag_der (der + counter, der_len - counter, &class,
+	  err = asn1_internal_get_tag_der (der + counter, der_len - counter, &class,
 	                          &len, NULL);
 	  if (err != ASN1_SUCCESS)
 	    goto error;
 	  counter += len;
 
-	  len2 = asn1_get_length_der (der + counter, der_len - counter, &len);
+	  len2 = asn1_internal_get_length_der (der + counter, der_len - counter, &len);
 	  if (len2 < 0)
 	    {
 	      err = ASN1_DER_ERROR;
@@ -1008,8 +1008,8 @@ error:
  *   length needed.
  **/
 int
-asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
-		 char *ErrorDescription)
+asn1_internal_der_coding (asn1_node element, const char *name, void *ider, int *len,
+			  char *ErrorDescription)
 {
   asn1_node node, p, p2;
   unsigned char temp[MAX(LTOSTR_MAX_SIZE, SIZEOF_UNSIGNED_LONG_INT * 3 + 1)];
@@ -1017,7 +1017,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
   int err;
   unsigned char *der = ider;
 
-  node = asn1_find_node (element, name);
+  node = asn1_internal_find_node (element, name);
   if (node == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
 
@@ -1099,7 +1099,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
 		  err = ASN1_VALUE_NOT_FOUND;
 		  goto error;
 		}
-	      len2 = asn1_get_length_der (p->value, p->value_len, &len3);
+	      len2 = asn1_internal_get_length_der (p->value, p->value_len, &len3);
 	      if (len2 < 0)
 		{
 		  err = ASN1_DER_ERROR;
@@ -1171,7 +1171,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
 	      err = ASN1_VALUE_NOT_FOUND;
 	      goto error;
 	    }
-	  len2 = asn1_get_length_der (p->value, p->value_len, &len3);
+	  len2 = asn1_internal_get_length_der (p->value, p->value_len, &len3);
 	  if (len2 < 0)
 	    {
 	      err = ASN1_DER_ERROR;
@@ -1221,7 +1221,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
 		  if (err != ASN1_SUCCESS)
 		    goto error;
 		}
-	      asn1_length_der (counter - len2, temp, &len3);
+	      asn1_internal_length_der (counter - len2, temp, &len3);
 	      max_len -= len3;
 	      if (max_len >= 0)
 		{
@@ -1266,7 +1266,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
 		  if (err != ASN1_SUCCESS)
 		    goto error;
 		}
-	      asn1_length_der (counter - len2, temp, &len3);
+	      asn1_internal_length_der (counter - len2, temp, &len3);
 	      max_len -= len3;
 	      if (max_len >= 0)
 		{
@@ -1284,7 +1284,7 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
 	      err = ASN1_VALUE_NOT_FOUND;
 	      goto error;
 	    }
-	  len2 = asn1_get_length_der (p->value, p->value_len, &len3);
+	  len2 = asn1_internal_get_length_der (p->value, p->value_len, &len3);
 	  if (len2 < 0)
 	    {
 	      err = ASN1_DER_ERROR;
@@ -1340,6 +1340,6 @@ asn1_der_coding (asn1_node element, const char *name, void *ider, int *len,
   err = ASN1_SUCCESS;
 
 error:
-  asn1_delete_structure (&node);
+  asn1_internal_delete_structure (&node);
   return err;
 }
